--[[
TODO:
Custom profile buttons
]]

local addon = CreateFrame("FRAME");

local _
local lastwarned
local warned = {}
local specid
local forceload = false
local raidid
local custom = false
local savefor
local wrongGlyph = false
local wrongTalent = false
local DefaultHiderFound = false
local selecteddifficulty
local lastframe

local texturedb = {

	glyph = {
		major =  {
			size = 84, left = 0.00390625, right = 0.33203125, top = 0.27539063, bottom = 0.43945313,
		};
		minor =  {
			size = 68, left = 0.33984375, right = 0.60546875, top = 0.27539063, bottom = 0.40820313,
		};
	};
	talentgreen = {
		left=0.00390625, right=0.74609375, top=0.37304688, bottom=0.47265625,
	};
	arrow = {
		left=0.4785156, right=0.3066406, top=0.2246094, bottom=0.3554688,
	};
}
local bossid = "default"
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_LOGIN")
addon:RegisterEvent("PLAYER_ENTERING_WORLD")
local function iDementia_CreateButtons()
	--AnchorFrame
	local anchorframe = CreateFrame("Frame", "iDementia_Anchor", UIParent, "SecureHandlerStateTemplate")
	RegisterStateDriver(anchorframe, "visibility", "[combat]hide")
	--RegisterStateDriver(your_frame_reference,"visibility","[combat]hide;show")
	--ConfigMenu
	local menuframe = CreateFrame("Frame", "iDementiaDropdownMenu")
	menuframe.displayMode = "MENU"
	local customloadmenuframe = CreateFrame("Frame", "iDementiaCustomLoadDropdownMenu")
	customloadmenuframe.displayMode = "MENU"
	--CreateSaveAsButton
	local saveasframe = CreateFrame("Button", "SaveAs", anchorframe)
	saveasframe:SetFrameStrata("HIGH")
	saveasframe:SetSize(20,20)
	--saveasframe:SetPoint("BOTTOMRIGHT", "PlayerTalentFrame", "BOTTOMRIGHT", -7, 4)
	local saveasbutton = saveasframe:CreateTexture()
	saveasbutton:SetAllPoints(saveasframe)
	saveasbutton:SetTexture("Interface\\AddOns\\iDementia\\media\\saveas")
	saveasframe:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText("Save as")
		GameTooltip:Show()
	end)
	saveasframe:SetScript("OnLeave", function(self, motion)
		GameTooltip:Hide()
	end)
	saveasframe:RegisterForClicks("AnyUp")
	saveasframe:SetScript("OnClick", iDementia_CreateMenu)
	local savefortargetframe = CreateFrame("Button", "SaveForTarget", anchorframe)
	savefortargetframe:SetFrameStrata("HIGH")
	savefortargetframe:SetSize(20,20)
	savefortargetframe:SetPoint("BOTTOMRIGHT", "SaveAs", "BOTTOMLEFT", -3, 0)
	local savefortargetbutton = savefortargetframe:CreateTexture()
	savefortargetbutton:SetAllPoints(savefortargetframe)
	savefortargetbutton:SetTexture("Interface\\AddOns\\iDementia\\media\\save")
	savefortargetframe:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")		
		GameTooltip:ClearLines()
		GameTooltip:SetText("Save for target")			
		GameTooltip:Show()
	end)
	savefortargetframe:SetScript("OnLeave", function(self, motion)
		GameTooltip:Hide()
	end)
	savefortargetframe:RegisterForClicks("AnyUp")
	savefortargetframe:SetScript("OnClick", function()
		if GlyphFrame:IsShown() then
			iDementia_SaveForTargetGlyphs()
		else
			iDementia_SaveForTargetTalents()
		end
	end)
	
	--LoadDefault
	local loaddefault = CreateFrame("Button", "LoadDefault", anchorframe)
	loaddefault:SetFrameStrata("HIGH")
	loaddefault:SetSize(25,25)
	loaddefault:SetPoint("BOTTOMRIGHT", "SaveForTarget", "BOTTOMLEFT", 0, -2)
	local loaddefaultbutton = loaddefault:CreateTexture()
	loaddefaultbutton:SetAllPoints(loaddefault)
	loaddefaultbutton:SetTexture("Interface\\AddOns\\iDementia\\media\\LoadDefault")
	loaddefault:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText("Left click to load default\nRight click to open custom profile list")
		GameTooltip:Show()
	end)
	loaddefault:SetScript("OnLeave", function(self, motion)
		GameTooltip:Hide()
	end)
	loaddefault:RegisterForClicks("AnyUp")
	loaddefault:SetScript("OnClick", function(self, button)
		if (button == "LeftButton") then
			custom = false
			bossid = "default"
			iDementiaUpdateButtons()
		elseif (button == "RightButton") then
			iDementia_CustomLoadMenu()
		end
	end)	
	

	--CheckAll
	local checkall = CreateFrame("Button", "CheckAllBoxes", anchorframe)
	checkall:SetFrameStrata("HIGH")
	checkall:SetSize(25,25)
	checkall:SetPoint("BOTTOMRIGHT", "LoadDefault", "BOTTOMLEFT", 0, -2)
	local checkallbutton = checkall:CreateTexture()
	checkallbutton:SetAllPoints(checkall)
	checkallbutton:SetTexture("Interface\\AddOns\\iDementia\\media\\selectall")
	checkall:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText("Select all")
		GameTooltip:Show()
	end)
	checkall:SetScript("OnLeave", function(self, motion)
		GameTooltip:Hide()
	end)
	checkall:RegisterForClicks("AnyUp")
	checkall:SetScript("OnClick", function()
		if PlayerTalentFrameTalents:IsShown() then
			for i = 1, GetMaxTalentTier() do
				local box = _G["TalentFrameCheckBox" .. i]
				box:SetChecked(true)
			end
		else
			for i = 1, 6 do
				local box = _G["GlyphCheckBox" .. i]
				box:SetChecked(true)
			end
		end	
	end)	
	
	--AnchorFrameForWarnings
	local f = CreateFrame("Frame", "WarningFrame", UIParent, "SecureHandlerStateTemplate")
	RegisterStateDriver(f, "visibility", "[combat]hide")
	f:SetPoint("CENTER", UIParent, "CENTER", 0, 300)
	f:SetSize(5,5)
	
	--GlyphWarning
	local glyphwarning = CreateFrame("Frame", "GlyphWarning", f)
	glyphwarning:SetPoint("RIGHT", f, "LEFT", -50,0)
	glyphwarning:SetSize(100,100)
	local glyphwarningtex = glyphwarning:CreateTexture()
	glyphwarningtex:SetTexture("Interface\\AddOns\\iDementia\\media\\glyphwarning")
	glyphwarningtex:SetAllPoints(glyphwarning)
	
	--TalentWarning
	local talentwarning = CreateFrame("Frame", "TalentWarning", f)
	talentwarning:SetPoint("LEFT", f, "RIGHT", 50,0)
	talentwarning:SetSize(100,100)
	local talentwarningtex = talentwarning:CreateTexture()
	talentwarningtex:SetTexture("Interface\\AddOns\\iDementia\\media\\talentwarning")
	talentwarningtex:SetAllPoints(talentwarning)
	if not InCombatLockdown() then
		WarningFrame:Hide()
	end
	--buttonAnchor
	local buttonAnchor = CreateFrame("Frame", "iDementiaButtonAnchor", UIParent, "SecureHandlerStateTemplate")
	RegisterStateDriver(buttonAnchor, "visibility", "[combat]hide")
	buttonAnchor:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	buttonAnchor:SetSize(5,5)
	buttonAnchor:SetFrameStrata("HIGH")
	buttonAnchor:Show()	
end
addon:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)
function addon:PLAYER_LOGIN()
	addon:RegisterEvent("PLAYER_REGEN_DISABLED")
	addon:RegisterEvent("PLAYER_REGEN_ENABLED")
	addon:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

	class = UnitClass("player")
	iDementia = iDementia or {}
	if (iDementia.warning == nil) then
		iDementia.warning = true
	end
	if (iDementia.class == nil) then
		iDementia.class = class
	end
	specid = GetSpecialization()
	if iDementia.warning then
		addon:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	end
	
	iDementia.specid = GetSpecialization()
	if not iDementia.class == class then --wipe db if saved class ~= current class (copy/paste wtf files):
		--TODO: wipe db
		iDementia.class = class
	end
	iDementia.default = iDementia.default or {
		[specid] = {
				glyphs = {
					major = {};
					minor = {};
				};
				talents = {};
		};
	}
	iDementia.raidid = iDementia.raidid or  {
		[1] = {
			name = "Outdoor",
			id = {};
		};
		[3] = {
			name = "10N",
			id = {};
		};
		[4] = {
			name = "25N",
			id = {};
		};
		[5] = {
			name = "10HC",
			id = {};
		};
		[6] = {
			name = "25HC",
			id = {};
		};
		[14] = {
			name = "Flex",
			id = {};
		};
	}
	iDementia.custom = iDementia.custom or {}
	GlyphFrame_LoadUI();
	TalentFrame_LoadUI();
end
function addon:ADDON_LOADED(arg1)
	if arg1 == "iDementia" then
		iDementia_CreateButtons()
	elseif arg1 == "Blizzard_TalentUI" then
		PlayerTalentFrameTalents:HookScript("OnShow", showtalents)
		PlayerTalentFrameTalents:HookScript("OnHide", hidetalents)
		PlayerTalentFrame:HookScript("OnShow", function()
			if not InCombatLockdown() then
				iDementiaButtonAnchor:Show()
			end
		end)
		PlayerTalentFrame:HookScript("OnHide", function()
			if not InCombatLockdown() then
				iDementiaButtonAnchor:Hide()
				GlyphWarning:Hide()
				TalentWarning:Hide()
			end
		end)
		addon:RegisterEvent("PLAYER_TALENT_UPDATE")
		showtalents()
	elseif arg1 == "Blizzard_GlyphUI" then
		GlyphFrame:HookScript("OnShow", showglyphs)
		GlyphFrame:HookScript("OnHide", hideglyphs)
		addon:RegisterEvent("GLYPH_UPDATED")
		addon:RegisterEvent("GLYPH_REMOVED")
		addon:RegisterEvent("GLYPH_ADDED")
		showglyphs()
	end
	if IsAddOnLoaded("Blizzard_TalentUI") and IsAddOnLoaded("Blizzard_GlyphUI") and IsAddOnLoaded("iDementia") then
			
		PlayerTalentFrameActivateButton:HookScript("OnShow", function()
			if not InCombatLockdown() then
				GlyphStack:Hide()
				TalentStack:Hide()
				iDementia_Anchor:Hide()
			end
		end)
		PlayerTalentFrameActivateButton:HookScript("OnHide", function()
			if not InCombatLockdown() then
				if PlayerTalentFrameTalents:IsShown() then
					GlyphStack:Hide()
					--TalentStack:Show()
					--iDementia_Anchor:Show()
					showtalents()
				elseif GlyphFrame:IsShown() then
					TalentStack:Hide()
					--GlyphStack:Show()					
					--iDementia_Anchor:Show()
					showglyphs()
				end	
			end
		end)
	end
	if IsAddOnLoaded("Aurora") then
		DefaultHiderFound = true
	end
end	
function addon:PLAYER_REGEN_DISABLED()
	if iDementia.warning then
		addon:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
	end
end
function addon:PLAYER_REGEN_ENABLED()
	if iDementia.warning then
		addon:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	end
end
function countEntries(t)
	if type(t) == "table" then
		local n = 0; 
		for _ in pairs(t) do 
		n = n + 1 end; 
		return n
	else
		return 0
	end
end

StaticPopupDialogs["iDementia_popup1"] = {
	text = "Boss ID:",
	button1 = "OK",
	button2 = "Cancel",
	OnShow = function(self) self.button1:Disable() end,
	EditBoxOnTextChanged = function(self)
		if (self:GetParent().editBox:GetNumber() > 0) then
			self:GetParent().button1:Enable()
		end
	end,
	OnAccept = function(self)
	bossid = self.editBox:GetNumber()
    StaticPopup_Show("iDementia_popup2")
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	preferredIndex = 2,
}
StaticPopupDialogs["iDementia_popup2"] = {
	text = "Boss Name",
	button1 = "OK",
	button2 = "Cancel",
	OnShow = function(self) self.button1:Disable() end,
	EditBoxOnTextChanged = function(self)
		if (self:GetParent().editBox:GetText()) then
			self:GetParent().button1:Enable()
		end
	end,
	OnAccept = function(self)
		local name = self.editBox:GetText()
		if (savefor == "GLYPH") then
			if not iDementia[bossid] then
				CreateNewBoss(bossid, name, selecteddifficulty)
				SaveCurrentGlyphs(bossid, selecteddifficulty)
			else
				SaveCurrentGlyphs(bossid, selecteddifficulty)
			end
		else
			if not iDementia[bossid] then
				CreateNewBoss(bossid, name, selecteddifficulty)
				SaveCurrentTalents(bossid, selecteddifficulty)
			else
				SaveCurrentTalents(bossid, selecteddifficulty)
			end
		end
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	preferredIndex = 2,
}
StaticPopupDialogs["iDementia_custom"] = {
	text = "Profile name",
	button1 = "OK",
	button2 = "Cancel",
	OnShow = function(self) self.button1:Disable() end,
	EditBoxOnTextChanged = function(self)
		if (self:GetParent().editBox:GetText()) then
			self:GetParent().button1:Enable()
		end
	end,
	OnAccept = function(self)
		local name = self.editBox:GetText()
		CreateNewBoss(name, nil, "custom")
		if (savefor == "GLYPH") then
			SaveCurrentGlyphs(name, "custom")
		else
			SaveCurrentTalents(name, "custom")
		end
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	preferredIndex = 2,
}
local function ShowGreen(id)
	local def = _G["GlyphFrameGlyph" .. id]
	if DefaultHiderFound then
		def.glyph:SetVertexColor(0,1,0)
	else
		def.ring:SetVertexColor(0,1,0)
	end
end
local function ShowRed(id)
	local def = _G["GlyphFrameGlyph" .. id]
	if DefaultHiderFound then
		def.glyph:SetVertexColor(1,0,0)
	else
		def.ring:SetVertexColor(1,0,0)
	end
end
local function ShowDefault(id)
	local def = _G["GlyphFrameGlyph" .. id]
	if DefaultHiderFound then
		def.glyph:SetVertexColor(1,1,1)
	else
		def.ring:SetVertexColor(1,1,1)
	end
end
function CreateNewBoss(id, unitname, sraidid)
	if not sraidid then
		iDementia.raidid[raidid].id[id] = {
			name = unitname,
			patch = GetBuildInfo(),
			spec = {
				[specid] ={
					glyphs = {
						major = {};
						minor = {};
					};
					talents = {};
				};
			};
		}
	elseif sraidid == "custom" then
		if iDementia.custom[id] then
			if iDementia.custom[id].spec[specid] then
			else 
				iDementia.custom[id].spec[specid].glyphs = iDementia.custom[id].spec[specid].glyphs or {
						major = {};
						minor = {};
					};
				iDementia.custom[id].spec[specid].talents = iDementia.custom[id].spec[specid].talents or {};
			end
		else
			iDementia.custom[id] = {
				name = id,
				spec = {
					[specid] ={
						glyphs = {
							major = {};
							minor = {};
						};
						talents = {};
					};
				};
			}
		end
	else
		iDementia.raidid[sraidid].id[id] = {
			name = unitname,
			patch = GetBuildInfo(),
			spec = {
				[specid] ={
					glyphs = {
						major = {};
						minor = {};
					};
					talents = {};
				};
			};
		}
	end
end
function iDementia_SaveForTargetGlyphs()
	if (UnitLevel("target") ~= -1 or UnitIsPlayer("target")) then
		return	
	else
		local id = tonumber(UnitGUID("target"):sub(6, 10), 16)
		local name = UnitName("target")
		if not iDementia.raidid[raidid].id[id] then 
			CreateNewBoss(id, name)
			SaveCurrentGlyphs(id, raidid)
		else
			SaveCurrentGlyphs(id, raidid)
		end
	end
end
function iDementia_SaveForTargetTalents()
	if (UnitLevel("target") ~= -1 or UnitIsPlayer("target")) then
		return	
	else
	--iDementia.raidid[raidid].id[currentbossid]
		local id = tonumber(UnitGUID("target"):sub(6, 10), 16)
		local name = UnitName("target")
		if not iDementia.raidid[raidid].id[id] then 
			CreateNewBoss(id, name ,raidid)
			SaveCurrentTalents(id, raidid)
		else
			SaveCurrentTalents(id, raidid)
		end
	end
end


function addon:PLAYER_ENTERING_WORLD()
	if (select(2,IsInInstance()) ~= "raid") then
		raidid = 1
	else
		local id = GetRaidDifficultyID()
		if (id == 3 or id == 4 or id == 5 or id == 6 or id == 14) then
			raidid = id
		else
			raidid = 1
		end
	end
end


function addon:ACTIVE_TALENT_GROUP_CHANGED()
	specid = GetSpecialization()
	bossid = "default"
	warned = {}
	if not iDementia.default[specid] then
		iDementia.default[specid] = {
				glyphs = {
					major = {};
					minor = {};
				};
				talents = {};
			}
		
	end
end
function addon:UPDATE_MOUSEOVER_UNIT()
	if (UnitLevel("mouseover") ~= -1 or UnitIsPlayer("mouseover")) then
		return	
	end
	local currentbossid = tonumber(UnitGUID("mouseover"):sub(6, 10), 16)
	if iDementia.raidid[raidid].id[currentbossid] then
		if iDementia.raidid[raidid].id[currentbossid].spec[specid] then
			bossid = currentbossid
		end
		custom = false
		iDementiaUpdateButtons()
	else
		custom = false
		bossid = "default"
		iDementiaUpdateButtons()
	end
end

function addon:GLYPH_UPDATED()
	iDementiaUpdateButtons()
end
function addon:GLYPH_REMOVED()
	iDementiaUpdateButtons()
end
function addon:GLYPH_ADDED()
	iDementiaUpdateButtons()
end
function addon:PLAYER_TALENT_UPDATE()
	iDementiaUpdateButtons()
end
function showglyphs()
	if not InCombatLockdown() then
		if not GlyphStack then
			if not SaveAs:GetPoint() then
				SaveAs:SetPoint("BOTTOMRIGHT", "PlayerTalentFrame", "BOTTOMRIGHT", -7, 4)
			end
			--Create GlyphCheckBox,RedBorder,GreenBorder and MissingGlyphs
			local glyphstack = CreateFrame("Frame", "GlyphStack", UIParent, "SecureHandlerStateTemplate")
			RegisterStateDriver(glyphstack, "visibility", "[combat]hide")
			--local glyphstack = CreateFrame("Frame", "GlyphStack")	
			glyphstack:SetFrameStrata("HIGH")
			for i = 1, 6 do				
				local glyphCheckBox = CreateFrame("CheckButton", "GlyphCheckBox" .. i, glyphstack, "UICheckButtonTemplate")
				if (i % 2 == 0 ) then
					glyphCheckBox:SetPoint("BOTTOMLEFT","GlyphFrameGlyph" .. i, "TOPRIGHT", -11,-11)
				else
					glyphCheckBox:SetPoint("BOTTOMLEFT","GlyphFrameGlyph" .. i, "TOPRIGHT", -19,-19)
				end
				glyphCheckBox:SetSize(28,28)
				
				--Buttons
				local GlyphMissingButton = CreateFrame("Button", "GlyphMissing" .. i, iDementiaButtonAnchor, "SecureActionButtonTemplate")
				GlyphMissingButton:RegisterForClicks("AnyUp")
				GlyphMissingButtonTexture = GlyphMissingButton:CreateTexture("GlyphMissingButtonTexture" .. i)	
				GlyphMissingButtonTexture:SetAllPoints(GlyphMissingButton)			
			end
			

			--ErrorArrow
			local errorarrow = CreateFrame("Button", "ErrorArrow", glyphstack)
			errorarrow:SetSize(70,35)		
			errorarrow:SetPoint("LEFT", GlyphFrameFilterDropDownButton, "RIGHT", 0, 0)
			local errorarrowtex = errorarrow:CreateTexture("errorarrowtex")
			errorarrowtex:SetAllPoints(errorarrow)		
			errorarrowtex:SetTexture("Interface\\AddOns\\iDementia\\media\\UI-TUTORIAL-FRAME")
			errorarrowtex:SetTexCoord(texturedb.arrow.left, texturedb.arrow.right, texturedb.arrow.top, texturedb.arrow.bottom)
			errorarrow:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
				GameTooltip:ClearLines()
				GameTooltip:SetText("You need to enable both filters before you can save glyphs")
				GameTooltip:Show()
			end)
			errorarrow:SetScript("OnLeave", function()
				GameTooltip:Hide()
			end)
			errorarrow:RegisterForClicks("AnyUp")
			errorarrow:SetScript("OnClick", function()
				errorarrow:Hide()
			end)
			errorarrow:Hide()

			if PlayerTalentFrameTalents:IsShown() then
				GlyphStack:Hide()
				iDementia_Anchor:Hide()				
			end
			GlyphStack:Hide()
		elseif not PlayerTalentFrameActivateButton:IsShown() then
			GlyphStack:Show()
			iDementia_Anchor:Show()
			iDementiaUpdateButtons()
		end
	end
end
function iDementia_CustomLoadMenu()
	iDementiaCustomLoadDropdownMenu.initialize = function(self, level)
		local info = {}
			if not level then return end
			wipe(info)
			if (level == 1) then
			--raiddifficitultylist
				info.text = "Difficulty"
				info.hasArrow = 1
				info.notCheckable = 1
				info.value = "raidid"
				UIDropDownMenu_AddButton(info, level)
			--Create Custom profile list
				for i,v in pairs(iDementia.custom) do
					if iDementia.custom[i].spec[specid] then
						info.text = iDementia.custom[i].name
						info.func = function()
							bossid = i
							custom = true
							iDementiaUpdateButtons()
						end
						info.hasArrow = nil
						info.notCheckable = 1
						UIDropDownMenu_AddButton(info, level)
					end
				end
			--Close
				info.text         = CLOSE
				info.func         = function() CloseDropDownMenus() end
				info.notCheckable = 1
				info.hasArrow = nil
				UIDropDownMenu_AddButton(info, level)
			elseif (level == 2) then
			--LoadRaidDifficulty
				for i,v in pairs(iDementia.raidid) do
					for k,v in pairs(iDementia.raidid[i].id) do
						if iDementia.raidid[i].id[k].spec[specid] then -- Check for current spec		
						--id-numid-spec-specid						
							info.text = iDementia.raidid[i].name
							info.notCheckable = 1
							info.hasArrow = 1
							info.value = i
							UIDropDownMenu_AddButton(info,level)
						end
						break
					end
				end
			elseif (level == 3) then
			--LoadBossesForRaidDifficulty
				for i,v in pairs(iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE].id) do
					info.text = iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE].id[i].name
					info.notCheckable = 1
					info.hasArrow = nil
					info.func = function()
						custom = false
						raidid = UIDROPDOWNMENU_MENU_VALUE
						bossid = i
						iDementiaUpdateButtons()
					end
					UIDropDownMenu_AddButton(info,level)
				end
			end	
	end
	ToggleDropDownMenu(1, nil, iDementiaCustomLoadDropdownMenu, LoadDefault, 0, 0)
end
function iDementia_CreateMenu()
	iDementiaDropdownMenu.initialize = function(self, level)
	local info = {}
		if not level then return end
		wipe(info)
		if (level == 1) then
		--Boss
			info.text = "Difficulty"
			info.hasArrow = 1
			info.notCheckable = 1
			info.value = "raidid"
			UIDropDownMenu_AddButton(info, level)
		--Default
			info.text = "default"
			info.hasArrow = nil
			info.func =	function() 
				if GlyphFrame:IsShown() then
					if not iDementia.default then
						CreateNewBoss("default", "default")
						SaveCurrentGlyphs("default")
					else
						SaveCurrentGlyphs("default")
					end
				elseif PlayerTalentFrameTalents:IsShown() then
					if not iDementia.default then
						CreateNewBoss("default", "default")
						SaveCurrentTalents("default")
					else
						SaveCurrentTalents("default")
					end
				end
			end
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		--Close
			info.text = CLOSE
			info.func = function() CloseDropDownMenus() end
			info.notCheckable = 1
			info.hasArrow = nil
			UIDropDownMenu_AddButton(info, level)
		
		
		
		--Load RaidDifficultyNames
		elseif (level == 2) then
			if (UIDROPDOWNMENU_MENU_VALUE == "raidid") then
				for i,v in pairs(iDementia.raidid) do
					info.text = iDementia.raidid[i].name
					info.notCheckable = 1
					info.hasArrow = 1
					info.value = i
					UIDropDownMenu_AddButton(info,level)
				end
					info.text = "Custom"
					info.notCheckable = 1
					info.hasArrow = 1
					info.value = "custom"
					UIDropDownMenu_AddButton(info,level)
			end
		elseif (level == 3) then
			if (UIDROPDOWNMENU_MENU_VALUE == "custom") then
				--Custom dropdown
				info.text = "Add New"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function()
					if GlyphFrame:IsShown() then
						savefor = "GLYPH"
					else
						savefor = "TALENT"
					end
					StaticPopup_Show("iDementia_custom")
				end
				UIDropDownMenu_AddButton(info,level)
				for i,v in pairs(iDementia.custom) do
					if iDementia.custom[i].spec[specid] then
						info.text = iDementia.custom[i].name
						info.notCheckable = 1
						info.hasArrow = 1
						info.value = {
							bossid = i,
							raidid = "custom",
						}
					UIDropDownMenu_AddButton(info,level)
					end
				end
			else
				--AddNewBossForSelectedDifficulty
				info.text = "Add New"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function()
					if GlyphFrame:IsShown() then
						savefor = "GLYPH"
					else
						savefor = "TALENT"
					end
					selecteddifficulty = UIDROPDOWNMENU_MENU_VALUE
					StaticPopup_Show("iDementia_popup1")
				end
				UIDropDownMenu_AddButton(info,level)
				
				--LoadBossesForRaidDifficulty
				for i,v in pairs(iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE].id) do
					info.text = iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE].id[i].name
					info.notCheckable = 1
					info.hasArrow = 1
					info.value = {
						bossid = i,
						raidid = UIDROPDOWNMENU_MENU_VALUE,
					}
					UIDropDownMenu_AddButton(info,level)
				end
			end
		--[[
		elseif (level == 4) then
			--LoadSpecs
			if (UIDROPDOWNMENU_MENU_VALUE.raidid == "custom") then
				--custom
				for i,v in pairs(iDementia.custom[UIDROPDOWNMENU_MENU_VALUE.bossid].spec) do
					info.text = select(2, GetSpecializationInfo(i))
					info.notCheckable = 1
					info.hasArrow = 1
					info.value = {
						bossid = UIDROPDOWNMENU_MENU_VALUE.bossid,
						raidid = "custom",
						specid = i,
					}
					UIDropDownMenu_AddButton(info,level)
				end
			else
				for i,v in pairs(iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec) do
					info.text = select(2, GetSpecializationInfo(i))
					info.notCheckable = 1
					info.hasArrow = 1
					info.value = {
						bossid = UIDROPDOWNMENU_MENU_VALUE.bossid,
						raidid = UIDROPDOWNMENU_MENU_VALUE.raidid,
						specid = i,
					}
					UIDropDownMenu_AddButton(info,level)
				end
			end
			]]
		elseif (level == 4) then
			if (UIDROPDOWNMENU_MENU_VALUE.raidid == "custom") then
				info.text = "Save"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function()
					CreateNewBoss(UIDROPDOWNMENU_MENU_VALUE.bossid, nil, UIDROPDOWNMENU_MENU_VALUE.raidid)
					if GlyphFrame:IsShown() then
						SaveCurrentGlyphs(UIDROPDOWNMENU_MENU_VALUE.bossid, UIDROPDOWNMENU_MENU_VALUE.raidid)
					else
						SaveCurrentTalents(UIDROPDOWNMENU_MENU_VALUE.bossid, UIDROPDOWNMENU_MENU_VALUE.raidid)
					end
				end
				UIDropDownMenu_AddButton(info,level)
				
				info.text = "Delete"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function()
					iDementia.custom[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[specid] = nil
					if (countEntries(iDementia.custom[UIDROPDOWNMENU_MENU_VALUE.bossid].spec) == 0) then
						iDementia.custom[UIDROPDOWNMENU_MENU_VALUE.bossid] = nil
					end
				end
				UIDropDownMenu_AddButton(info,level)
			else
				--LoadDelete+OverWrite
				info.text = "Save"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function() 
					if GlyphFrame:IsShown() then
						SaveCurrentGlyphs(UIDROPDOWNMENU_MENU_VALUE.bossid, UIDROPDOWNMENU_MENU_VALUE.raidid)
					elseif PlayerTalentFrameTalents:IsShown() then
						SaveCurrentTalents(UIDROPDOWNMENU_MENU_VALUE.bossid, UIDROPDOWNMENU_MENU_VALUE.raidid)
					end
				end
				UIDropDownMenu_AddButton(info,level)
				
				info.text = "Delete"
				info.notCheckable = 1
				info.hasArrow = nil
				info.func = function() 
					if GlyphFrame:IsShown() then
						iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[GetSpecialization()].glyphs = nil
					elseif PlayerTalentFrameTalents:IsShown() then
						iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[GetSpecialization()].talents = nil
					end
					if not iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[GetSpecialization()].glyphs and not iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[GetSpecialization()].talents then
					iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec[GetSpecialization()] = nil
						if countEntries(iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid].spec) == 0 then
							iDementia.raidid[UIDROPDOWNMENU_MENU_VALUE.raidid].id[UIDROPDOWNMENU_MENU_VALUE.bossid] = nil
						end
					end
				end
				UIDropDownMenu_AddButton(info,level)
			end
		end
	end	
	ToggleDropDownMenu(1, nil, iDementiaDropdownMenu, SaveAs, 0, 0)
end

function hideglyphs()
	if not InCombatLockdown() then
		GlyphStack:Hide()
		--SaveAs:Hide()
		--SaveForTarget:Hide()
		--LoadDefault:Hide()
		GlyphWarning:Hide()
		--CheckAllBoxes:Hide()
		iDementia_Anchor:Hide()
	end
end
function showtalents()
	if not InCombatLockdown() then
		if not TalentStack then
			if not SaveAs:GetPoint() then
				SaveAs:SetPoint("BOTTOMRIGHT", "PlayerTalentFrame", "BOTTOMRIGHT", -7, 4)
			end
				--GlyphFrame_LoadUI()
				--showglyphs()
			local talentstack = CreateFrame("Frame", "TalentStack", UIParent, "SecureHandlerStateTemplate")
			RegisterStateDriver(talentstack, "visibility", "[combat]hide")
				for i = 1, GetMaxTalentTier() do
					--Checkboxes
					local f = _G["PlayerTalentFrameTalentsTalentRow" .. i]
					f.level:Hide()
					local frame = CreateFrame("CheckButton", "TalentFrameCheckBox" .. i, talentstack, "UICheckButtonTemplate")
					frame:ClearAllPoints()
					frame:SetPoint("LEFT","PlayerTalentFrameTalentsTalentRow" .. i, "LEFT", 13,0)
					frame:SetSize(30,30)
					frame:SetFrameStrata("HIGH")
					--GreenGlow
					local ringgreen = CreateFrame("Frame", "TalentRingGreen" .. i, talentstack)
					local ft = ringgreen:CreateTexture("TalentRingGreenTex" .. i)
					ft:SetTexture("Interface\\AddOns\\iDementia\\media\\talentmaingreen")		
					ft:SetTexCoord(texturedb.talentgreen.left, texturedb.talentgreen.right, texturedb.talentgreen.top, texturedb.talentgreen.bottom);
					local fname = _G["PlayerTalentFrameTalentsTalentRow" .. i .. "Talent1"]
					ft:SetAllPoints(fname.knownSelection)
					ft:Hide()
				end
			TalentStack:SetFrameStrata("HIGH")
			TalentStack:Hide()
			--TalentButtons
			for i = 1, 6 do
				local talentButton = CreateFrame("Button", "iDementiaTalentButton" .. i, iDementiaButtonAnchor, "SecureActionButtonTemplate")
				talentButton:RegisterForClicks("AnyUp")
				talentButton:SetSize(30,30)
				local talentButtonTexture = talentButton:CreateTexture("iDementiaTalentButtonTex" .. i)
				talentButtonTexture:SetAllPoints(talentButton)
			end
		elseif not PlayerTalentFrameActivateButton:IsShown() then
			TalentStack:Show()
			iDementia_Anchor:Show()
			iDementiaUpdateButtons()
		end
		iDementiaButtonAnchor:SetPoint("BOTTOMRIGHT", PlayerTalentFrame, "BOTTOMRIGHT", 0, -9)
	end
end
function hidetalents()
	if not InCombatLockdown() then
		TalentStack:Hide()
		--SaveAs:Hide()
		--SaveForTarget:Hide()
		--LoadDefault:Hide()
		TalentWarning:Hide()
		--CheckAllBoxes:Hide()
		iDementia_Anchor:Hide()
	end
end
function iDementiaUpdateButtons()
	if not InCombatLockdown() then
		local firstframe = true
		lastframe = false
		local glyphs
		if custom then
			glyphs = iDementia.custom[bossid].spec[specid].glyphs
		elseif (bossid == "default") then
			glyphs = iDementia.default[specid].glyphs
		else
			glyphs = iDementia.raidid[raidid].id[bossid].spec[specid].glyphs		
		end

		local currentGlyphs = {
			right = {
				major = {};
				minor = {};
			};
			wrong = {
				major = {};
				minor = {};
			};
			neutral = {
				major = {};
				minor = {};
			};
		}
		showing = {}
		local majors = countEntries(glyphs.major)
		local minors = countEntries(glyphs.minor)		
		local wrong = {
			major = false,
			minor = false,
		}
		for i = 1, 6 do
			local missing = _G["GlyphMissing" .. i]
			missing:Hide()
			local _,glyphType,_,id = GetGlyphSocketInfo(i)
			if (glyphType == 1) then
				glyphType = "major"
			else
				glyphType = "minor"
			end
			--if not id then
				--id = "empty"
			--end
			if (glyphs[glyphType][id]) then
				currentGlyphs.right[glyphType][id] = true
			elseif glyphType == "major" then
				currentGlyphs.wrong.major[i] = true
				if not wrong.major then 
					wrong.major = true 
				end
			elseif glyphType == "minor" then
				currentGlyphs.wrong.minor[i] = true
				if not wrong.minor then 
					wrong.minor = true 
				end
			end
		end
		--testdb
		local tempdb = {
			major = {};
			minor = {};
			}
		local n = 1
		for i in pairs(glyphs.major) do
			tempdb.major[n] = i
			n = n + 1	
		end
		n = 1
		for i in pairs(glyphs.minor) do	
			tempdb.minor[n] = i
			n = n +1
		end
		
		if minors+majors > 0 then
			if wrong.major or wrong.minor then
				wrongGlyph = true
				iDementia_ShowWarning()
			else
				wrongGlyph = false
			end
		end
		local GlyphSlotID = 2
		local found = false
		for i = 1, 3 do --majors
			if tempdb.major[i] then
				found = false
				if currentGlyphs.wrong.major[GlyphSlotID] then					
					for i,v in pairs(tempdb.major) do
						if not currentGlyphs.right.major[v] and not found then
							ShowRed(GlyphSlotID)
							local currentbutton = _G["GlyphMissing" .. GlyphSlotID]
							local tex = _G["GlyphMissingButtonTexture" .. GlyphSlotID]	
							local name = glyphs.major[v].name	
							tex:SetTexture(glyphs.major[v].icon)
							currentbutton:SetSize(30,30)
							currentbutton:Show()
							currentbutton:SetFrameStrata("HIGH")
							currentbutton:ClearAllPoints()
							if firstframe then				
								currentbutton:SetPoint("TOPRIGHT", "iDementiaButtonAnchor", "TOPRIGHT", 0, 0)
								firstframe = false
							else
								currentbutton:SetPoint("TOPRIGHT", lastframe, "TOPLEFT", -2, 0)
							end		
							local emt = GlyphSlotID
							currentbutton:SetScript("OnMouseDown", function()				
								currentbutton:SetAttribute("type", "glyph")
								currentbutton:SetAttribute("glyph", name)
								currentbutton:SetAttribute("slot", emt)	
							end)				
							--framecount = framecount + 1
							lastframe = currentbutton
							found = true
							tempdb.major[i] = nil
						end
					end			
				else
					if (majors == 3 and wrong.major) then
						ShowGreen(GlyphSlotID)
					else
						ShowDefault(GlyphSlotID)
					end
				end
			else
				if (majors == 3 and wrong.major) then
					ShowGreen(GlyphSlotID)
				else
					ShowDefault(GlyphSlotID)
				end
			end
			GlyphSlotID = GlyphSlotID + 2
		end
		GlyphSlotID = 1
		for i = 1, 3 do --minors
			if tempdb.minor[i] then
				found = false
				if currentGlyphs.wrong.minor[GlyphSlotID] then					
					for i,v in pairs(tempdb.minor) do
						if not currentGlyphs.right.minor[v] and not found then
							ShowRed(GlyphSlotID)
							local currentbutton = _G["GlyphMissing" .. GlyphSlotID]
							local tex = _G["GlyphMissingButtonTexture" .. GlyphSlotID]			
							local name = glyphs.minor[v].name	
							tex:SetTexture(glyphs.minor[v].icon)
							currentbutton:SetSize(24,24)
							currentbutton:Show()
							currentbutton:SetFrameStrata("HIGH")
							currentbutton:ClearAllPoints()
							if firstframe then					
								currentbutton:SetPoint("TOPRIGHT", "iDementiaButtonAnchor", "TOPRIGHT", 0, 0)
								firstframe = false
							else
								currentbutton:SetPoint("TOPRIGHT", lastframe, "TOPLEFT", -2, 0)
							end		
							local emt = GlyphSlotID
							currentbutton:SetScript("OnMouseDown", function()				
								currentbutton:SetAttribute("type", "glyph")
								currentbutton:SetAttribute("glyph", name)
								currentbutton:SetAttribute("slot", emt)	
							end)				
							--framecount = framecount + 1
							lastframe = currentbutton
							found = true
							tempdb.minor[i] = nil
						end
					end			
				else
					if (minors == 3 and wrong.minor) then
						ShowGreen(GlyphSlotID)
					else
						ShowDefault(GlyphSlotID)
					end
				end
			else
				if (minors == 3 and wrong.minor) then
					ShowGreen(GlyphSlotID)
				else
					ShowDefault(GlyphSlotID)
				end
			end
			GlyphSlotID = GlyphSlotID + 2
		end
		--TalentTest
		local rowslot
		local talents
		if custom then
			talents = iDementia.custom[bossid].spec[specid].talents
		elseif (bossid == "default") then
			talents = iDementia.default[specid].talents
		else
			talents = iDementia.raidid[raidid].id[bossid].spec[specid].talents
		end
		for i = 1, GetMaxTalentTier() do
		local currentbutton = _G["iDementiaTalentButton" .. i]
		currentbutton:Hide()
			if talents[i] then
				local fname = _G["PlayerTalentFrameTalentsTalentRow" .. i .. "Talent" .. talents[i].slot]
				local tex = _G["TalentRingGreenTex" .. i]
				local buttontex = _G["iDementiaTalentButtonTex" .. i]				
				if GetTalentRowSelectionInfo(i) then
					rowslot = 0
				else
					rowslot = select(2,GetTalentRowSelectionInfo(i))-(i-1)*3
				end
				if (talents[i].slot ~= rowslot) then
					tex:SetAllPoints(fname.knownSelection);
					fname.knownSelection:Hide()
					tex:Show()
					wrongTalent = true
					iDementia_ShowWarning()
					local talentIndex = (i-1)*3+talents[i].slot
					local currentTalentFrameButton = _G["PlayerTalentFrameTalentsTalentRow" .. i .. "Talent" .. rowslot]
					local icon = select(2,GetTalentInfo(talentIndex))
					local talentRow = i
					---TalentButton
					currentbutton:Show()
					buttontex:SetTexture(icon)
					currentbutton:ClearAllPoints()
					if GetTalentRowSelectionInfo(talentRow) then
						buttontex:SetVertexColor(0,1,0)
					else
						buttontex:SetVertexColor(1,0,0)
					end
					if firstframe then					
						currentbutton:SetPoint("TOPRIGHT", "iDementiaButtonAnchor", "TOPRIGHT", 0, 0)
						firstframe = false
					else
						currentbutton:SetPoint("TOPRIGHT", lastframe, "TOPLEFT", -2, 0)
					end
					lastframe = currentbutton
					currentbutton:SetScript("OnMouseDown", function(self, button)
						if GetTalentRowSelectionInfo(talentRow) then
							LearnTalent(talentIndex)
						else
							local popupButton
							if StaticPopup1.text:GetText() then
								if string.find(StaticPopup1.text:GetText(), "Are you sure you want to remove") then
									popupButton = StaticPopup1Button1
								end
							elseif StaticPopup2.text:GetText() then
								if string.find(StaticPopup2.text:GetText(), "Are you sure you want to remove") then
									popupButton = StaticPopup2Button1
								end
							elseif StaticPopup3.text:GetText() then
								if string.find(StaticPopup3.text:GetText(), "Are you sure you want to remove") then
									popupButton = StaticPopup3Button1
								end
							end
							currentbutton:SetAttribute("type", "click")
							currentbutton:SetAttribute("*clickbutton1", popupButton)
							currentbutton:SetAttribute("*clickbutton2", currentTalentFrameButton)
						end
					end)					
				else
					fname.knownSelection:Show()
					tex:Hide()
				end
			end
		end
	end
end

function SaveCurrentGlyphs(id, raidid)
	if (IsGlyphFlagSet(8) and IsGlyphFlagSet(16) and GlyphFrameSearchBox:GetText() == "Search") then
		if ErrorArrow:IsShown() then
			ErrorArrow:Hide()
		end
		local glyphs
		if (id == "default") then
			iDementia.default[specid].glyphs = {
				major = {};
				minor = {};
			}
			glyphs = iDementia.default[specid].glyphs
		elseif (raidid == "custom") then
			iDementia.custom[id].spec[specid].glyphs = {
				major = {};
				minor = {};
			}
			glyphs = iDementia.custom[id].spec[specid].glyphs
		else
			iDementia.raidid[raidid].id[id].spec[specid].glyphs = {
				major = {};
				minor = {};
			}
			glyphs = iDementia.raidid[raidid].id[id].spec[specid].glyphs
		end

		for i = 1, 6 do
			local f = _G["GlyphCheckBox" .. i]
			if f:GetChecked() then
				local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i)
				if (glyphType == 1) then
					glyphType = "major"
				else
					glyphType = "minor"
				end
				if glyphSpellID then
					local name = select(1, GetSpellInfo(glyphSpellID));
					if string.match(name, "Glyph of the (.*)") then
						name = string.match(name, "Glyph of the (.*)")
					else
						name = string.match(name, "Glyph of (.*)")
					end
					for i = 1, GetNumGlyphs() do
						local glyphindexname = GetGlyphInfo(i)
						if string.match(glyphindexname, ".*" .. name) then
							name = glyphindexname
							break
						end
					end
					glyphs[glyphType][glyphSpellID] = {
						name = name,
						icon = icon,
					};
				end
			end
		end
		bossid = "default"
	else
		ErrorArrow:Show()
	end
end
function SaveCurrentTalents(id, raidid)
	local talents
	if (id == "default") then
		iDementia.default[specid].talents = {}
		talents = iDementia.default[specid].talents
	elseif (raidid == "custom") then
		iDementia.custom[id].spec[specid].talents = {}
		talents = iDementia.custom[id].spec[specid].talents
	else
		iDementia.raidid[raidid].id[id].spec[specid].talents = {}
		talents = iDementia.raidid[raidid].id[id].spec[specid].talents
	end
	for i = 1, GetMaxTalentTier() do
		if not GetTalentRowSelectionInfo(i) then
			local checkbox = _G["TalentFrameCheckBox" .. i]
			if checkbox:GetChecked() then
				talents[i] = {
					name = GetTalentInfo(select(2,GetTalentRowSelectionInfo(i))),
					slot = select(2,GetTalentRowSelectionInfo(i))-(i-1)*3,
					}
			end
		end
	end
	bossid = "default"
end
local function ToggleWarning()
	if iDementia.warning then
		addon:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
		iDementia.warning = false
		print("iDementia: Mouseover loading and warnings disabled")
	else
		iDementia.warning = true
		addon:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		print("iDementia: Mouseover loading and warnings enabled")
	end
end
function iDementia_ShowWarning()
	if not InCombatLockdown() and iDementia.warning then
		WarningFrame:Show()
		if warned[bossid] then
			return
		elseif (lastwarning == "default" and bossid == "default") then 
			return
		else
			if wrongGlyph then
				GlyphWarning:Show()
			end
			if wrongTalent then
				TalentWarning:Show()
			end
			if bossid ~= "default" then
				warned[bossid] = true
			end
		end
		lastwarning = bossid
	end
end
SLASH_IDEMENTIA1 = "/idementia"
SLASH_IDEMENTIA2 = "/id"
SlashCmdList["IDEMENTIA"] = function()
		ToggleWarning()
end





